statistics-0.13.2.3: A library of statistical types, data, and functions

Copyright | 2014 Bryan O'Sullivan
License | BSD3
Safe Haskell | None
Language | Haskell98

Statistics.Regression

Description

Functions for regression analysis.

Synopsis

- olsRegress :: [Vector] -> Vector -> (Vector, Double)
- ols :: Matrix -> Vector -> Vector
- rSquare :: Matrix -> Vector -> Vector -> Double
- bootstrapRegress :: GenIO -> Int -> Double -> ([Vector] -> Vector -> (Vector, Double)) -> [Vector] -> Vector -> IO (Vector Estimate, Estimate)

# Documentation

olsRegress Source

Arguments

:: [Vector] | Non-empty list of predictor vectors. Must all have the same length. These will become the columns of the matrix A solved by `ols`.
-> Vector | Responder vector. Must have the same length as the predictor vectors.
-> (Vector, Double) |

Perform an ordinary least-squares regression on a set of predictors, and calculate the goodness-of-fit of the regression.

The returned pair consists of:

- A vector of regression coefficients. This vector has one more element than the list of predictors; the last element is the y-intercept value.
- R², the coefficient of determination (see `rSquare` for details).

ols Source

Arguments

:: Matrix | A has at least as many rows as columns.
-> Vector | b has the same length as columns in A.
-> Vector |

Compute the ordinary least-squares solution to A x = b.

rSquare Source

Arguments

:: Matrix | Predictors (regressors).
-> Vector | Responders.
-> Vector | Regression coefficients.
-> Double |

Compute R², the coefficient of determination that indicates goodness-of-fit of a regression.

This value will be 1 if the predictors fit perfectly, dropping to 0 if they have no explanatory power.

bootstrapRegress Source

Arguments

:: GenIO |
-> Int | Number of resamples to compute.
-> Double | Confidence interval.
-> ([Vector] -> Vector -> (Vector, Double)) | Regression function.
-> [Vector] | Predictor vectors.
-> Vector | Responder vector.
-> IO (Vector Estimate, Estimate) |

Bootstrap a regression function. Returns both the results of the regression and the requested confidence interval values.